#include <drivers/gpio.h>

const struct device *gpio_dev;
#define GPIO_PIN 13
static struct gpio_callback button_cb_data;

void button_pressed(const struct device *dev, struct gpio_callback *cb,
		    uint32_t pins)
{
	printk("Button1 pressed at %" PRIu32 "\n", k_cycle_get_32());
}


void main(void)
{
	int err;

	printk("GPIO sample without using dts\n");

	gpio_dev = device_get_binding("GPIO_0");
	if (gpio_dev == NULL) {
		printk("Could not get device GPIO_0\n");
		return;
	}
	err = gpio_pin_configure(gpio_dev, GPIO_PIN, GPIO_INPUT | GPIO_PULL_UP | GPIO_ACTIVE_LOW); 
	if (err != 0) {
		printk("Failed to configure pin %d\n", GPIO_PIN);
		return;
	}
	err = gpio_pin_interrupt_configure(gpio_dev, GPIO_PIN, GPIO_INT_EDGE_TO_ACTIVE);
	if (err != 0) {
		printk("failed to configure pin %d as interrupt\n", GPIO_PIN);
		return;
	}

	gpio_init_callback(&button_cb_data, button_pressed, BIT(GPIO_PIN));
	gpio_add_callback(gpio_dev, &button_cb_data);
}